/* *****************************************************************************
 Propiedad Intelectual
 Nombre:	Rafael Alberto Moreno Parra
 C.C.:		16.832.929 Jdi/Valle
 
 Programa: Applet Java de graficacin lineal

 Descripcion:	Este programa grafica una ecuacin de una variable independiente
				y una dependiente del modelo F(X)

 Fecha:			Diciembre 27 de 1998

****************************************************************************** */
import java.applet.*;
import java.awt.*;
import java.util.*;
import EvalExpr; // Evaluador de expresiones
import frmAlifeSim1; //Cuadro de dilogo
import cSerVivo;
import cMutacion;

//Applet
public class EvolSim1 extends Applet implements Runnable
{
	//Trabajar con hilos
	private Thread	 m_thRunner = null;

	//Variables globales
	String m_sSerieNum = new String();  //El ambiente en cadena
	
	//Cuadro de dialogo
	frmAlifeSim1 m_frmDlg1;

	//Ser vivo
	cSerVivo objSerVivo;

	//Mutacion
	cMutacion objMutacion;

	//Contador de #intentos o seres generados
	int m_iContIntento;

	//Probabilidades
	int m_iProbX, m_iProbP, m_iProbN;


	public EvolSim1()
	{
		// TODO: Add constructor code here
	}

	public String getAppletInfo()
	{
		return "Name: EvolSim1\r\n" +
		       "Author: Rafael Alberto Moreno Parra\r\n" +
		       "Created with Microsoft Visual J++ Version 1.1\r\n" +
		       "\r\n" +
		       "A-Life: Vida Artificial\r\n" +
		       "Simulacion I: La simulacin consiste en generar aleatoriamente expresiones\r\n" +
		       "matemticas de una variable independiente X, despus se hace el estudio\r\n" +
		       "de la serie generada por esta expresin y se compara con la serie numrica predefinida \r\n" +
		       "(ambiente). Solo sobrevive la expresin que su serie se acerque ms a la predefinida.\r\n" +
		       "\r\n" +
		       "\r\n" +
		       "\r\n" +
		       "";
	}


	public void init()
	{
    	int iCont;
		String sAcum="";
		
		resize(640, 240);

		//Inicializa el ambiente por defecto
		m_sSerieNum="2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,";

		// Llama el cuadro de dialogo con valores por defecto
		m_frmDlg1 = new frmAlifeSim1(this);
		m_frmDlg1.CreateControls();
		m_frmDlg1.txtSerie.setText(m_sSerieNum);

		//Inicializa con valores por defecto
		m_frmDlg1.txtProbX.setText("30");
		m_frmDlg1.txtProbP.setText("15");
		m_frmDlg1.txtProbN.setText("55");
		
		//Ser vivo
		objSerVivo = new cSerVivo();

		//Mutacion
		objMutacion = new cMutacion();

		IniciarValores();
	}

	public void destroy()
	{
		// TODO: Place applet cleanup code here
	}

	public void paint(Graphics g)
	{
	}

	public void start()
	{
		if (m_thRunner == null)
		{
			m_thRunner = new Thread(this);
			m_thRunner.start();
		}
	}
	
	public void stop()
	{
		if (m_thRunner != null)
		{
			m_thRunner.stop();
			m_thRunner=null;
		}	

	}

	public void run()
	{
		float dTotDifer=0;
		Float fPrimerP, fSegundP, fTercerP;
		float dPrimerP, dSegundP, dTercerP;

		while(true)
		{
			//Crea la expresion
			objMutacion.vCrearExpresion(18, m_iProbX, m_iProbP, m_iProbN);
			m_frmDlg1.txtEvaluando.setText(objMutacion.sAcum);
			
			//Sube el numero de seres generados
			m_iContIntento++;
			m_frmDlg1.txtIntento.setText(String.valueOf(m_iContIntento));

			//La envia a evaluar
			objSerVivo.sExpresion = objMutacion.sAcum;

			if (objSerVivo.iAdaptarse01() == 0)
			{
				dTotDifer = (float) objSerVivo.dAdaptarse02();

				//Ahora se ordena los primeros tres puestos en adaptacin.
				//Chequea el primer puesto
				fPrimerP = Float.valueOf(m_frmDlg1.txtAprox01.getText());
				fSegundP = Float.valueOf(m_frmDlg1.txtAprox02.getText());
				fTercerP = Float.valueOf(m_frmDlg1.txtAprox03.getText());

				dPrimerP = fPrimerP.floatValue();
				dSegundP = fSegundP.floatValue();
				dTercerP = fTercerP.floatValue();

				if (dTotDifer<dPrimerP)
				{
					//Mueve los puestos
					m_frmDlg1.txtExpr03.setText(m_frmDlg1.txtExpr02.getText());
					m_frmDlg1.txtAprox03.setText(m_frmDlg1.txtAprox02.getText());

					m_frmDlg1.txtExpr02.setText(m_frmDlg1.txtExpr01.getText());
					m_frmDlg1.txtAprox02.setText(m_frmDlg1.txtAprox01.getText());
				
					//Coloca el primer lugar
					m_frmDlg1.txtExpr01.setText(objSerVivo.sExpresion);
					m_frmDlg1.txtAprox01.setText(String.valueOf(dTotDifer));
				}
				else if (dTotDifer<dSegundP)
				{
					//Mueve los puestos
					m_frmDlg1.txtExpr03.setText(m_frmDlg1.txtExpr02.getText());
					m_frmDlg1.txtAprox03.setText(m_frmDlg1.txtAprox02.getText());
					
					//Coloca el segundo lugar
					m_frmDlg1.txtExpr02.setText(objSerVivo.sExpresion);
					m_frmDlg1.txtAprox02.setText(String.valueOf(dTotDifer));
				}
				else if (dTotDifer<dTercerP)
				{
					//Coloca el tercer lugar
					m_frmDlg1.txtExpr03.setText(objSerVivo.sExpresion);
					m_frmDlg1.txtAprox03.setText(String.valueOf(dTotDifer));
				}


			}
		}
	}

	// Manejador de eventos
    public boolean handleEvent( Event e )
    {
        boolean bReturn = false;

        if (e.target == m_frmDlg1.cmdOK)
		{
            bReturn = routeEvent_cmdOK(e);
			start();
		}

		if (e.target == m_frmDlg1.cmdStop)
			stop();
 
		if (bReturn == true)
            return true;
        else
            return super.handleEvent(e);
    }

	
	// Este es el evento de dar click sobre el boton
	private boolean routeEvent_cmdOK(Event e)
    {
        boolean bReturn = false;
		int iCont;
		String sAcum="";
		
        if (e.id == Event.ACTION_EVENT)
			IniciarValores();
	
       return bReturn;
	}

	void IniciarValores()
	{
		int iCont;
		String sAcum="";
		
		//El ambiente
		m_sSerieNum = m_frmDlg1.txtSerie.getText();
		objSerVivo.vAmbiente(m_sSerieNum);
		
		//Valores iniciales de los puestos
		m_frmDlg1.txtExpr01.setText("??????????????");
		m_frmDlg1.txtExpr02.setText("??????????????");
		m_frmDlg1.txtExpr03.setText("??????????????");
		m_frmDlg1.txtAprox01.setText("99999999");
		m_frmDlg1.txtAprox02.setText("99999999");
		m_frmDlg1.txtAprox03.setText("99999999");

		//Probabilidades de creacion de expresiones
		m_iProbX = Integer.parseInt(m_frmDlg1.txtProbX.getText());
		m_iProbP = Integer.parseInt(m_frmDlg1.txtProbP.getText());
		m_iProbN = Integer.parseInt(m_frmDlg1.txtProbN.getText());


		//Contador de Intentos
		m_iContIntento = 0;
	}

}
